Description

When exported in pdf format, there are too many whitespace under each note (attached).

As far as I can see, white space is automatically generated equal to the line number of the note.

I tested on Redmine 3.4.4.stable.17198 and Redmine 3.1.7.stable.17140, this issue persists.

Hope this issue is fixed soon.

Thank you !

Associated revisions

Revision 17574 - 2018-10-06 02:11 - Go MAEDA

PDF export has too many whitespaces (#28565).

Contributed by Jun NAITOH.

Revision 17575 - 2018-10-06 02:17 - Go MAEDA

Merged r17574 from trunk to 3.4-stable (#28565).

Revision 17576 - 2018-10-06 02:18 - Go MAEDA

Merged r17574 from trunk to 3.3-stable (#28565).

History

#1 - 2018-04-17 12:49 - Guillermo ML

I can confirm this behaviour on 3.3.1.stable, 3.4.3.stable and 3.4.4.stable

The number of blank lines after each note seems to be identical to the number of lines of text in the note.

#2 - 2018-04-30 02:40 - Go MAEDA

- Status changed from New to Confirmed

- Target version set to Candidate for next minor release

Reproducible in the current trunk (r17315).

#3 - 2018-08-01 04:28 - Tyler Nguyen

I'm not a professional programmer. Hope someone can help me solve this problem, it is also quite important.

#4 - 2018-08-02 07:36 - Bernhard Rohloff

- File fix_height_of_line_break_in_issue_pdf.diff added

- File ecookbook-2.pdf added

The behavior is caused by source:trunk/lib/redmine/export/pdf/issues_pdf_helper.rb#L234

After each comment block the method pdf.ln gets called without an argument. In this case the space height is equal to the last block.

https://www.rubydoc.info/gems/rbpdf/1.18.3/RBPDF:Ln

I've attached a patch to set the height to what I think is an appropriate value.

#5 - 2018-08-02 10:36 - Bernhard Rohloff

- File fix_height_of_line_break_in_issue_pdf_v2.diff added
I've found the same behavior for associated revisions and comments after journal entries.

Attached is a second patch to fix also these whitespace issues.

The spacings meet my esthetical reqiurements but feedback on this is hearty welcomed. :-)

#6 - 2018-08-07 06:37 - Bernhard Rohloff

- File pdf_formatting_before_and_after.png added

This is the result of my patch but it's quite difficult to show how it looks in a document...

 pdf_formatting_before_and_after.png 

#7 - 2018-08-07 07:28 - Marius BĂLTEANU

LGTM

#8 - 2018-08-21 00:51 - Jun NAITOH

I think this is a problem of rbpdf.

Please wait for a while because we are working on correcting it.

#9 - 2018-08-21 05:38 - Bernhard Rohloff

Jun NAITOH wrote:

I think this is a problem of rbpdf.

Please wait for a while because we are working on correcting it.

 Do you think this is a bug or do you want to change the default behavior of the pdf.ln method?

Because as I wrote in #28565-6 that's the exact default behavior described in the rbpdf documentation.

... By default, the value equals the height of the last printed cell.

#10 - 2018-08-22 16:01 - Jun NAITOH

- File rbpdf_cell.png added

- File rbpdf_multi_cell.png added

Bernhard Rohloff wrote:

Jun NAITOH wrote:

I think this is a problem of rbpdf.

Please wait for a while because we are working on correcting it.

 Do you think this is a bug or do you want to change the default behavior of the pdf.ln method?

 Yes, I think it is a bug in rbpdf.

Because as I wrote in #28565-6 that's the exact default behavior described in the rbpdf documentation.

... By default, the value equals the height of the last printed cell.

 

By default, the value is intended to be the height of the last printed cell.

However, the current implementation has become the height of the last printed by MultiCell.

This means the height of multiple rows(MultiCell), but the expected specification is the height of one rows (Cell = charactor's hight).
rbpdf_cell.png 
rbpdf_multi_cell.png 

#11 - 2018-10-06 01:47 - Jun NAITOH

- File rbpdf_1_19_5__1_19_6.png added

- File test-6_rbpdf_1_19_5.pdf added

- File test-6_rbpdf_1_19_6.pdf added
- File Wiki_rbpdf_1_19_5.pdf added

- File Wiki_rbpdf_1_19_6.pdf added

I'm sorry it takes time to fix it.

This problem fixed by rbpdf 1.19.6.

please bundle update.

The fixed issues is as follows.

https://github.com/naitoh/rbpdf/issues/47

 rbpdf_1_19_5__1_19_6.png 

#12 - 2018-10-06 02:12 - Go MAEDA

- Status changed from Confirmed to Resolved

- Assignee set to Go MAEDA

#13 - 2018-10-06 02:23 - Go MAEDA

- Subject changed from PDF export has too many whitespace to PDF export has too many whitespaces

- Status changed from Resolved to Closed

- Target version changed from Candidate for next minor release to 3.3.9

- Resolution set to Fixed

Updated the Gemfile in the repository. Thank you for working hard on fixing this issue.
